#!/usr/bin/perl

package tet;

require "$ENV{\"TET_ROOT\"}/lib/perl/api.pl";

$journal_path="tet_xres";
unlink($journal_path);
if (open(JOURNAL_HANDLE_REAL,">>$journal_path")) {
	$JOURNAL_HANDLE=JOURNAL_HANDLE_REAL;
} else {
	$JOURNAL_HANDLE=STDOUT;
}

#no matter what, make sure output is unbuffered.
select((select($JOURNAL_HANDLE), $|=1)[0]);


$code=$ENV{"TET_CODE"};

if (defined($code) && $code ne "") {
        ; # ok
} else {
	$code=tet_code;
}

local($TET_CODE_HANDLE);
local($fail)=0;

if (open(TET_CODE_HANDLE,"<$code")) {
        @TET_CODE_FILE=<TET_CODE_HANDLE>;
        close(TET_CODE_HANDLE);
} else {
 
        if (tet_code ne "$code") {
                &error("could not open results code file $code");
        }
        @TET_CODE_FILE=("0   PASS        Continue\n",
                "1   FAIL        Continue\n",
                "2   UNRESOLVED  Continue\n",
                "3   NOTINUSE    Continue\n",
                "4   UNSUPPORTED Continue\n",
                "5   UNTESTED    Continue\n",
                "6   UNINITIATED Continue\n",
                "7   NORESULT    Continue\n");

}

sub test_info {
	my ($tnum, $message) = @_;
	$activity = $tnum;
	chomp $message;
	&output(520, "$tnum 1 0 0", $message);
}

sub test_result {
	my ($tnum, $result) = @_;
	$time=&time;
	if ("$result" eq "") {
		$result=NORESULT;
		$resnum = 7;
	} elsif (&getcode($result)!=0) {     # sets $resnum & $abort
		$result="NO RESULT NAME";
		$resnum=-1;
	}

	&output(220, "$tnum $resnum $time", "$result");
}

sub test_start {
	my ($tnum) = @_;
	$time=&time;
	&output(400, "$tnum $tnum $time", "IC Start");
	&output(200,"$tnum $time","TP Start");
	&setcontext;
}

sub tc_start {
	my ($tnum, $message) = @_;
	my $time=&time;
	$activity=$tnum;
	&output(10, "$message $time", "TC Start");
	&output(15, "3.7-lite 1", "TCM Start");
}

sub tp_start {
	my ($tnum, $message) = @_;
	my $time=&time;
	&output(200, "$tnum $time", "TP Start, $message");
}

sub test_end {
	my ($tnum)  = @_;
	$time=&time;
	&output(410, "$tnum 0 $time", "IC End");
	&output(80, "$tnum 0 $time", "TC End");
}

sub time {
	($sec,$min,$hour)=localtime;
	$r=sprintf("%02d:%02d:%02d",$hour,$min,$sec);
}

sub test_time {
	($sec,$min,$hour,$mday,$mon,$year)=localtime;
	$year += 1900;
	$r=sprintf("%02d:%02d:%02d %04d%02d%02d",$hour,$min,$sec,$year,$mon+1,$mday)
}

sub test_header {
	my $login=getpwuid($<);
	my $id_string = "0|3.7-lite " . &tet::test_time . "|User: " . $login . ", Command line: " . $0 . "\n"; 
	printf($JOURNAL_HANDLE $id_string);
	my $uname = `uname -snrvm`;
	chomp $uname;
	my $host_info = "5|" . $uname . "|System Information\n";
	printf($JOURNAL_HANDLE $host_info);
	printf($JOURNAL_HANDLE "20||Config Start\n");
	my $test_ver = `cat ../VERSION`;
	#chomp $test_ver;
	$test_ver = "30||VSX_NAME=" . $test_ver;
	printf($JOURNAL_HANDLE $test_ver);
	$perl_ver = "30||PERL_VERSION=" . $]; 
	printf($JOURNAL_HANDLE "$perl_ver\n");
	printf($JOURNAL_HANDLE "40||Config End\n");
}

sub test_count {
	my ($tname, $tcount) = @_;
	my $tstring = "70||total tests in " . $tname . " " . $tcount . "\n";
	printf($JOURNAL_HANDLE $tstring);
}

sub test_footer {
	my $time=&time;
	$activity=$time;
	&output(900, "", "TCC End");
}
