# A simple test to assure that all required LSB Perl modules are present
# Robert Schweikert <rschweikert@novell.com>
# See the License file distributed with this test suite for license infomation

use Test::More tests => 259;

BEGIN {
    use_ok( 'AnyDBM_File' );
    use_ok( 'Attribute::Handlers' );
    use_ok( 'AutoLoader' );
    use_ok( 'AutoSplit' );
    use_ok( 'B::Concise' );
    use_ok( 'B::Debug' );
    use_ok( 'B::Deparse' );
    use_ok( 'B::Lint' );
    use_ok( 'B::Showlex' );
    use_ok( 'B::Terse' );
    use_ok( 'B::Xref' );
    use_ok( 'Benchmark' );
    use_ok( 'CGI' );
    use_ok( 'CGI::Apache' );
    use_ok( 'CGI::Carp' );
    use_ok( 'CGI::Cookie' );
# dropped per bug 3146 
#    use_ok( 'CGI::Fast' );
    use_ok( 'CGI::Pretty' );
    use_ok( 'CGI::Push' );
# dropped per bug 3459
#   use_ok( 'CGI::Switch' );
    use_ok( 'CGI::Util' );
    use_ok( 'CPAN' );
    use_ok( 'CPAN::FirstTime' );
    use_ok( 'CPAN::Nox' );
    use_ok( 'Carp' );
    use_ok( 'Carp::Heavy' );
# dropped per bug 3459
#    use_ok( 'Class::ISA' );
    use_ok( 'Class::Struct' );
    use_ok( 'Cwd' );
    use_ok( 'DB' );
    use_ok( 'DBM_Filter' );
# dropped per bug 3151
#    use_ok( 'DBM_Filter::compress' );
    use_ok( 'DBM_Filter::encode' );
    use_ok( 'DBM_Filter::int32' );
    use_ok( 'DBM_Filter::null' );
    use_ok( 'DBM_Filter::utf8' );
    use_ok( 'Data::Dumper' );
# Use of DProf in this way is not supported by Perl
# We have a separate test to verify DProf is present.
# note per bug 3459 this is dropped from LSB entirely
#    use_ok( 'Devel::DProf' );
    use_ok( 'Devel::PPPort' );
    use_ok( 'Devel::Peek' );
    use_ok( 'Devel::SelfStubber' );
    use_ok( 'Digest' );
    use_ok( 'Digest::MD5' );
    use_ok( 'Digest::base' );
    use_ok( 'Digest::file' );
    use_ok( 'DirHandle' );
    use_ok( 'Dumpvalue' );
    use_ok( 'Encode' );
    use_ok( 'Encode::Alias' );
    use_ok( 'Encode::Byte' );
    use_ok( 'Encode::CJKConstants' );
    use_ok( 'Encode::CN' );
    use_ok( 'Encode::CN::HZ' );
    use_ok( 'Encode::Config' );
    use_ok( 'Encode::EBCDIC' );
    use_ok( 'Encode::Encoder' );
    use_ok( 'Encode::Encoding' );
    use_ok( 'Encode::Guess' );
    use_ok( 'Encode::JP' );
    use_ok( 'Encode::JP::H2Z' );
    use_ok( 'Encode::JP::JIS7' );
    use_ok( 'Encode::KR' );
    use_ok( 'Encode::KR::2022_KR' );
    use_ok( 'Encode::MIME::Header' );
    use_ok( 'Encode::Symbol' );
    use_ok( 'Encode::TW' );
    use_ok( 'Encode::Unicode' );
    use_ok( 'Encode::Unicode::UTF7' );
    use_ok( 'English' );
    use_ok( 'Env' );
    use_ok( 'Exporter' );
    use_ok( 'Exporter::Heavy' );
    use_ok( 'ExtUtils::Command' );
    use_ok( 'ExtUtils::Command::MM' );
    use_ok( 'ExtUtils::Install' );
    use_ok( 'ExtUtils::Installed' );
    use_ok( 'ExtUtils::Liblist' );
    use_ok( 'ExtUtils::Liblist::Kid' );
    use_ok( 'ExtUtils::MM_Unix' );
    use_ok( 'ExtUtils::MY' );
    use_ok( 'ExtUtils::MakeMaker' );
    use_ok( 'ExtUtils::MakeMaker::Config' );
# LSB should not require this module, see Bug 3147
#    use_ok( 'ExtUtils::MakeMaker::bytes' );
    use_ok( 'ExtUtils::Manifest' );
    use_ok( 'ExtUtils::Mkbootstrap' );
    use_ok( 'ExtUtils::Mksymlists' );
    use_ok( 'ExtUtils::Packlist' );
    use_ok( 'ExtUtils::testlib' );
    use_ok( 'Fatal' );
    use_ok( 'Fcntl' );
    use_ok( 'File::Basename' );
    use_ok( 'File::CheckTree' );
    use_ok( 'File::Compare' );
    use_ok( 'File::Copy' );
    use_ok( 'File::DosGlob' );
    use_ok( 'File::Find' );
    use_ok( 'File::Glob' );
    use_ok( 'File::Path' );
    use_ok( 'File::Spec' );
    use_ok( 'File::Spec::Functions' );
    use_ok( 'File::Spec::Unix' );
    use_ok( 'File::Temp' );
    use_ok( 'File::stat' );
    use_ok( 'FileCache' );
    use_ok( 'FileHandle' );
    use_ok( 'Filter::Simple' );
    use_ok( 'Filter::Util::Call' );
    use_ok( 'FindBin' );
    use_ok( 'GDBM_File' );
    use_ok( 'Getopt::Long' );
    use_ok( 'Getopt::Std' );
    use_ok( 'Hash::Util' );
    use_ok( 'I18N::Collate' );
    use_ok( 'I18N::LangTags' );
    use_ok( 'I18N::LangTags::Detect' );
    use_ok( 'I18N::LangTags::List' );
    use_ok( 'I18N::Langinfo' );
    use_ok( 'IO' );
    use_ok( 'IO::Dir' );
    use_ok( 'IO::File' );
    use_ok( 'IO::Handle' );
    use_ok( 'IO::Pipe' );
    use_ok( 'IO::Poll' );
    use_ok( 'IO::Seekable' );
    use_ok( 'IO::Select' );
    use_ok( 'IO::Socket' );
    use_ok( 'IO::Socket::INET' );
    use_ok( 'IO::Socket::UNIX' );
    use_ok( 'IPC::Msg' );
    use_ok( 'IPC::Open2' );
    use_ok( 'IPC::Open3' );
    use_ok( 'IPC::Semaphore' );
    use_ok( 'IPC::SysV' );
    use_ok( 'List::Util' );
# dropped per bug 3282
#   use_ok( 'Locale::Constants' );
    use_ok( 'Locale::Country' );
    use_ok( 'Locale::Currency' );
    use_ok( 'Locale::Language' );
    use_ok( 'Locale::Maketext' );
    use_ok( 'Locale::Script' );
    use_ok( 'MIME::Base64' );
    use_ok( 'MIME::QuotedPrint' );
    use_ok( 'Math::BigFloat' );
    use_ok( 'Math::BigInt' );
    use_ok( 'Math::BigInt::Calc' );
    use_ok( 'Math::BigInt::CalcEmu' );
    use_ok( 'Math::BigRat' );
    use_ok( 'Math::Complex' );
    use_ok( 'Math::Trig' );
    use_ok( 'Memoize' );
    use_ok( 'Memoize::AnyDBM_File' );
    use_ok( 'Memoize::Expire' );
    use_ok( 'Memoize::ExpireFile' );
    use_ok( 'Memoize::ExpireTest' );
    use_ok( 'Memoize::SDBM_File' );
    use_ok( 'Memoize::Storable' );
    use_ok( 'NEXT' );
    use_ok( 'Net::Cmd' );
    use_ok( 'Net::Config' );
    use_ok( 'Net::Domain' );
    use_ok( 'Net::FTP' );
    use_ok( 'Net::NNTP' );
    use_ok( 'Net::Netrc' );
    use_ok( 'Net::POP3' );
    use_ok( 'Net::Ping' );
    use_ok( 'Net::SMTP' );
    use_ok( 'Net::Time' );
    use_ok( 'Net::hostent' );
    use_ok( 'Net::netent' );
    use_ok( 'Net::protoent' );
    use_ok( 'Net::servent' );
# The O module is an interface to the compiler backend it cannot be tested in
# this fashion
#    use_ok( 'O' );
    use_ok( 'Opcode' );
    use_ok( 'POSIX' );
    use_ok( 'PerlIO' );
    use_ok( 'PerlIO::encoding' );
    use_ok( 'PerlIO::scalar' );
    use_ok( 'PerlIO::via' );
    use_ok( 'PerlIO::via::QuotedPrint' );
    use_ok( 'Pod::Checker' );
    use_ok( 'Pod::Find' );
    use_ok( 'Pod::Functions' );
    use_ok( 'Pod::Html' );
    use_ok( 'Pod::InputObjects' );
    use_ok( 'Pod::LaTeX' );
    use_ok( 'Pod::Man' );
    use_ok( 'Pod::ParseLink' );
    use_ok( 'Pod::ParseUtils' );
    use_ok( 'Pod::Parser' );
    use_ok( 'Pod::Perldoc::ToChecker' );
# Upstream bug
#    use_ok( 'Pod::Perldoc::ToMan' );
    use_ok( 'Pod::Perldoc::ToNroff' );
    use_ok( 'Pod::Perldoc::ToPod' );
# dropped per bug 3150 (ToTk, ToXml, ToRtf)
#    use_ok( 'Pod::Perldoc::ToRtf' );
    use_ok( 'Pod::Perldoc::ToText' );
#    use_ok( 'Pod::Perldoc::ToTk' );
#    use_ok( 'Pod::Perldoc::ToXml' );
    use_ok( 'Pod::PlainText' );
# dropped per bug 3459
#   use_ok( 'Pod::Plainer' );
    use_ok( 'Pod::Select' );
    use_ok( 'Pod::Text' );
    use_ok( 'Pod::Text::Color' );
    use_ok( 'Pod::Text::Overstrike' );
    use_ok( 'Pod::Text::Termcap' );
    use_ok( 'Pod::Usage' );
    use_ok( 'SDBM_File' );
    use_ok( 'Safe' );
    use_ok( 'Scalar::Util' );
    use_ok( 'Search::Dict' );
    use_ok( 'SelectSaver' );
    use_ok( 'SelfLoader' );
# dropped per bug 3459
#   use_ok( 'Shell' );
    use_ok( 'Socket' );
    use_ok( 'Storable' );
    use_ok( 'Sys::Hostname' );
    use_ok( 'Sys::Syslog' );
    use_ok( 'Term::ANSIColor' );
    use_ok( 'Term::Complete' );
    use_ok( 'Term::ReadLine' );
    use_ok( 'Test::Builder' );
    use_ok( 'Test::Builder::Module' );
    use_ok( 'Test::Builder::Tester' );
    use_ok( 'Test::Builder::Tester::Color' );
    use_ok( 'Test::Harness' );
    use_ok( 'Test::More' );
    use_ok( 'Test::Simple' );
    use_ok( 'Text::Abbrev' );
    use_ok( 'Text::Balanced' );
    use_ok( 'Text::ParseWords' );
    use_ok( 'Text::Soundex' );
    use_ok( 'Text::Tabs' );
    use_ok( 'Text::Wrap' );
    use_ok( 'Tie::Array' );
    use_ok( 'Tie::File' );
    use_ok( 'Tie::Handle' );
    use_ok( 'Tie::Hash' );
    use_ok( 'Tie::Memoize' );
    use_ok( 'Tie::RefHash' );
    use_ok( 'Tie::Scalar' );
    use_ok( 'Tie::SubstrHash' );
    use_ok( 'Time::HiRes' );
    use_ok( 'Time::Local' );
    use_ok( 'Time::gmtime' );
    use_ok( 'Time::localtime' );
    use_ok( 'Time::tm' );
    use_ok( 'Unicode::Collate' );
    use_ok( 'Unicode::Normalize' );
    use_ok( 'Unicode::UCD' );
    use_ok( 'User::grent' );
    use_ok( 'User::pwent' );
    use_ok( 'attributes' );
# Cannot be tested in this fashion, needs separate test
#    use_ok( 'autouse' );
    use_ok( 'base' );
    use_ok( 'bigint' );
    use_ok( 'bignum' );
    use_ok( 'bigrat' );
# Cannot be tested in this fashion, needs separate test
#    use_ok( 'blib' );
    use_ok( 'bytes' );
# Cannot be tested in this fashion, needs separate test
#    use_ok( 'charnames' );
    use_ok( 'constant' );
    use_ok( 'diagnostics' );
# Cannot be tested in this fashion, needs separate test
#    use_ok( 'fields' );
# Cannot be tested in this fashion, needs separate test
#    use_ok( 'filetest' );
# Cannot be tested in this fashion, needs separate test
#    use_ok( 'if' );
    use_ok( 'integer' );
    use_ok( 'less' );
    use_ok( 'locale' );
# Cannot be tested in this fashion, needs separate test
#    use_ok( 'open' );
    use_ok( 'overload' );
# Cannot be tested in this fashion, needs separate test
#    use_ok( 're' );
    use_ok( 'sigtrap' );
# Cannot be tested in this fashion, needs separate test
#    use_ok( 'sort' );
    use_ok( 'strict' );
    use_ok( 'subs' );
    use_ok( 'utf8' );
    use_ok( 'warnings' );
    use_ok( 'warnings::register' );
}
